#ifndef __DEMO_H__
#define __DEMO_H__
/************************************************************************/
/* 
<HTML>
<TITLE>DEMO HEADER WITH HTML </TITLE>
<H1> Header:  DEMO HEADER WITH HTML (demo.h) </H1><UL>
<LI> Purpose:     IDD and header for DEMO
<LI> Language/Compiler/O/S:   ANSI C, SCO CC or GNU gcc:  UNIX 
                              BCC 3.0:  DOS/Windows 3.1 
<LI> Author:      Wade Hampton
<LI> Date:        9/26/95
<LI> Revision History [from RCS]
<UL><PRE>

 $Log$

</PRE>
</UL></UL>
<H1> Scope:</H1>
<H2> Identification:</H2>
This is xxxx, the IDD for an internal protocol for ABC.

<H2> System Overview:</H2>
The ABC is a complex system designed to interface to the JKL and
to handle multiple inputs from XYZ.  This is the 
IDD for an internal protocl.

<H2> Document Overview:</H2>
This is the IDD for internal messages from the XYZ to the ABC.

<H2> Notes: </H1><OL>
<LI>This is a demo of the use of an HTML IDD embedded in a .H file.
</OL></UL>
<H1> Applicable Documents:</H1>

<H2> Government: </H1><OL>
<LI>TBD
</OL>

<H2> Non-Government: </H1>
<OL>
<LI>TBD
</OL>

<H1> Terms and Abbreviations:</H1>
<UL>
<LI>HTML - Hypertext Markup Language
<LI>HTMLEXTRACT - HTML extraction tool
</UL>

<H1> Interface Design:</H1>
This interface is an internal interface between an XYZ and 
the ABC.  It is designed to incorporate lots of neat stuff.
<P>

This is designed to be as simple a protocol as possible.

<H2> Interface Diagrams: </H2>
<PRE>
  +-----+   +-----+         +-------------------+
  | XYZ |---| ABC |---------| another black box |
  +-----+ ^ +-----+         +-------------------+
          +- this protocol
</PRE>
<P>
This could be a GIF or JPEG, e.g., from a graphics package....
<P>
<H2> Interface Name: </H2>
This interface shall be called XYZ protocol Alpha.

<H2> Data Elements: </H2>
The following are the main data elements:
<OL>
<LI> time  - seconds since 1/1/1970
<LI> event - the XYZ event
<LI> data  - event-specific data or NULL for no data
</OL>
<P>
Valid events are:
<OL>
<LI>Startup - remote device started up
<LI>Shutdown - remote device is shutting down
<LI>Status - remote device status message
<LI>Error - error on remote device
</OL>

<H2> Message Descriptions: </H2>
Each message shall consist of the time (seconds), 
event, and data.  The format of the message is TBD (however
prototype structures are included herein).
<P>
If the data field is not used and the data item is a structure, the
data item shall be a null pointer.  If the data field is a string
(static allocation), it shall contain an ASCII NULL (zero length
C string).
</HTML>
 
 *----------------------------------------------------------------------*/
/* TYPES- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* INCLUDE FILES- - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* CONSTANTS- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*
<HTML>
<H1>Data Elements (message): </H1>
<H2>Time:</H2>
This is seconds since January 1, 1970 (Unix time).  
<P>
Format:
<UL>
<LI>seconds - 32 bit unsigned integer
</UL>
<PRE>
*/
typedef struct CLOCK_TAG
{
  time_t   ulSeconds;
} CLOCK_TYP;
/*
</PRE>

<H2>Event:</H2>
Events are valid XYZ device events. Device events are 
error, powerup, powerdown, etc.  
<P>
<ITALIC>This is an italic comment<ITALIC>
<PRE>
*/
typedef unsigned short EVENT_TYP;

/*
</PRE>

<H2>Event Data:</H2>
Event data is a string of data associated with the event.  For
most events, this is not applicable.  For errors this a description
of the error.
<PRE>
*/
#ifndef LPSTR
#define LPSTR char *
#endif
typedef LPSTR DATA_TYP;
typedef char  DATA_TYP2;
#define       DATA_LEN_DEF 64
/*
</PRE>

<H2>Event Message Format:</H2>
This is the structure of a message consisting of time,  
event, and data.
<PRE>
*/
/* structure with pointer */
typedef struct MSG_TYP1
{
  CLOCK_TYP    strTime;
  EVENT_TYP    wEvent;
  DATA_TYP     lpData;
} MSG_TYP1;

/* structure w/o pointer */
typedef struct MSG_TYP2
{
  CLOCK_TYP    strTime;
  EVENT_TYP    wEvent;
  DATA_TYP2    caData[DATA_LEN_DEF];
} MSG_TYP2;
/*
</PRE>

<H1>Data Elements (event): </H1>

<H2>Startup:</H2>
The remote device started up.  Initialize the interface and XXX.
<P>
Data is optional; if received, the startup data could be logged.
<PRE>
*/
#define STARTUP          17
/*
</PRE>

<H2>Shutdown:</H2>
A remote device is shutting down (graceful shutdown).  Terminate 
all processing and report console message.
<P>
Data is optional; if received, the shutdown data could be logged.
<PRE>
*/
#define SHUTDOWN         18
/*
</PRE>

<H2>Status:</H2>
A report of status of the remote device.  This may be received 
in any state.  The data will contain the status of the device in 
a device-specific format (TBD).
<PRE>
*/
#define STATUS           19
/*
</PRE>

<H2>Error:</H2>
A report of an error on remote device.  This may be received
in any state.  Typical processing is to XXX and return to an idle 
state.  The event should be logged.  
<P>
The data field should contain a device-specific description of the error.
<PRE>
*/
#define ERROR            20
/*
</PRE>

</HTML>
/* LOCAL DATA - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* EXTERNAL PROCEDURES- - - - - - - - - - - - - - - - - - - - - - - - - */
/* EXTERNAL DATA- - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* PROTOTYPES - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*
<HTML> 
<CENTER><HR> Copyright (C) 1995, 1996, Joe Blo </CENTER>
</HTML> 
 */
/************************************************************************/
#endif
